/*
 * aryeh's memory functions
 */

void **alloc2d(int varsize, int n, int p);
void ***alloc3d(int varsize, int n, int p, int q);
void ****alloc4d(int varsize, int n, int p, int q, int r);
void *****alloc5d(int varsize, int n, int p, int q, int r, int s);



/*
 *  Function:  alloc2d
 *  ------------------
 *  Allocate a two-dimensional array.
 */

void **alloc2d(int varsize, int n, int p) {
    int k ;
    void **a ;

    if ((a = (void **) malloc(n*sizeof(void *))) == NULL) { 
        printf ("Memory Error in alloc2d.\n") ;
        exit(1) ;
    }

    for (k = 0 ; k < n ; k++) {
        if ((a[k] = (void *) malloc(p*varsize)) == NULL) { 
            printf ("Memory Error in alloc2d.\n") ;
            exit(1) ;
        }
    }
    return a ;
}



void ***alloc3d(int varsize, int n, int p, int q) {
    int k,j ;
    void ***a ;

    if ((a = (void ***) malloc(n*sizeof(void **))) == NULL) { 
        printf ("Memory Error in alloc2d.\n") ;
        exit(1) ;
    }

    for (k = 0 ; k < n ; k++) {
        if ((a[k] = (void **) malloc(p*sizeof(void *))) == NULL) { 
            printf ("Memory Error in alloc2d.\n") ;
            exit(1) ;
        }
	for( j = 0 ; j < p ; j++){
		if ((a[k][j] = (void *) malloc(q*varsize)) == NULL) { 
			printf ("Memory Error in alloc2d.\n") ;
			exit(1) ;
		}
	}
    }
    return a ;
}

void ****alloc4d(int varsize, int n, int p, int q, int r) {
    int k,j,i ;
    void ****a ;

    if ((a = (void ****) malloc(n*sizeof(void ***))) == NULL) { 
        printf ("Memory Error in alloc2d.\n") ;
        exit(1) ;
    }

    for (k = 0 ; k < n ; k++) {
        if ((a[k] = (void ***) malloc(p*sizeof(void **))) == NULL) { 
            printf ("Memory Error in alloc2d.\n") ;
            exit(1) ;
        }
	for( j = 0 ; j < p ; j++){
		if ((a[k][j] = (void **) malloc(q*sizeof(void *))) == NULL) { 
			printf ("Memory Error in alloc2d.\n") ;
			exit(1) ;
		}
		for( i = 0 ; i < q; i++){	
			if( (a [k][j][i] = (void *) malloc(r*varsize))
				==NULL){
				printf("Memory error in alloc4d.\n");
				exit(1);
			}
		}
	}
    }
    return a;
}

void *****alloc5d(int varsize, int n, int p, int q, int r, int s) {
    int k,j,i,m;
    void *****a ;

    if ((a = (void *****) malloc(n*sizeof(void ****))) == NULL) { 
        printf ("Memory Error in alloc5d.\n") ;
        exit(1) ;
    }

    for (k = 0 ; k < n ; k++) {
        if ((a[k] = (void ****) malloc(p*sizeof(void ***))) == NULL) { 
            printf ("Memory Error in alloc5d.\n") ;
            exit(1) ;
        }
	for( j = 0 ; j < p ; j++){
		if ((a[k][j] = (void ***) malloc(q*sizeof(void **))) == NULL) { 
			printf ("Memory Error in alloc5d.\n") ;
			exit(1) ;
		}
		for( i = 0 ; i < q; i++){	
			if( (a [k][j][i] = (void **) malloc(r*sizeof(void *)))
				==NULL){
				printf("Memory error in alloc5d.\n");
				exit(1);
			}
			for( m = 0 ; m < r; m++){
				if( (a[k][j][i][m] = (void *) malloc(s*varsize)) == NULL){
					printf("Memory error in alloc5d.\n");
					exit(1);
				}
			}
		}
	}
    }
    return a;
}


